import config from './config.json' assert {type: "json"};
import { MatrixClient, SimpleFsStorageProvider, AutojoinRoomsMixin } from "matrix-bot-sdk";
import fs from "fs";

const storage = new SimpleFsStorageProvider("storage.json");
const client = new MatrixClient(config.baseUrl, config.token, storage);

AutojoinRoomsMixin.setupOnClient(client)
client.start().then(() => console.log(`Client has started!`));

let messageCounter = 0;

// ? event listener: logs messages sent into file
client.on("room.message", (roomId, event) => {
    if (!event["content"] || event["sender"] === config.userId) return;
    messageCounter = messageCounter + 1;
    fs.appendFile('training-matrix.txt', event["content"]["body"] + "\n", function (err) {
        if (err) throw err;
        console.log(messageCounter + "\t" + event["content"]["body"]);
    });

    // ? send message every N messages using the training data
    if (!(messageCounter % 7)) {
        client.sendText(roomId, "Hello, World!"); // TODO: exec py function to gen message str 
    };
});

